From 83496ebf335d1df433b5047902478af7ae89411d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 04 2020 07:36:53 +0000
Subject: [PATCH 526/2232] Move error reporting span computation to tokens.rs


---

diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 13cbfcf..934c85b 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -1,5 +1,7 @@
 use crate::syntax::atom::Atom::*;
-use crate::syntax::{Derive, ExternFn, Receiver, Ref, Signature, Slice, Ty1, Type, Var};
+use crate::syntax::{
+    Derive, Enum, ExternFn, ExternType, Receiver, Ref, Signature, Slice, Struct, Ty1, Type, Var,
+};
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{quote_spanned, ToTokens};
 use syn::Token;
@@ -76,6 +78,30 @@ impl ToTokens for Derive {
     }
 }
 
+impl ToTokens for ExternType {
+    fn to_tokens(&self, tokens: &mut TokenStream) {
+        // Notional token range for error reporting purposes.
+        self.type_token.to_tokens(tokens);
+        self.ident.to_tokens(tokens);
+    }
+}
+
+impl ToTokens for Struct {
+    fn to_tokens(&self, tokens: &mut TokenStream) {
+        // Notional token range for error reporting purposes.
+        self.struct_token.to_tokens(tokens);
+        self.ident.to_tokens(tokens);
+    }
+}
+
+impl ToTokens for Enum {
+    fn to_tokens(&self, tokens: &mut TokenStream) {
+        // Notional token range for error reporting purposes.
+        self.enum_token.to_tokens(tokens);
+        self.ident.to_tokens(tokens);
+    }
+}
+
 impl ToTokens for ExternFn {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         // Notional token range for error reporting purposes.
diff --git a/syntax/types.rs b/syntax/types.rs
index e09b5cf..f0ef3a8 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -2,7 +2,6 @@ use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::set::OrderedSet as Set;
 use crate::syntax::{Api, Derive, Enum, ExternFn, ExternType, Struct, Type};
 use proc_macro2::Ident;
-use quote::quote;
 use std::collections::{BTreeMap as Map, HashSet as UnorderedSet};
 use syn::{Error, Result};
 
@@ -131,24 +130,15 @@ impl<'t, 'a> IntoIterator for &'t Types<'a> {
 }
 
 fn duplicate_struct(strct: &Struct) -> Error {
-    let struct_token = strct.struct_token;
-    let ident = &strct.ident;
-    let range = quote!(#struct_token #ident);
-    Error::new_spanned(range, "duplicate type")
+    Error::new_spanned(strct, "duplicate type")
 }
 
 fn duplicate_enum(enm: &Enum) -> Error {
-    let enum_token = enm.enum_token;
-    let ident = &enm.ident;
-    let range = quote!(#enum_token #ident);
-    Error::new_spanned(range, "duplicate type")
+    Error::new_spanned(enm, "duplicate type")
 }
 
 fn duplicate_type(ety: &ExternType) -> Error {
-    let type_token = ety.type_token;
-    let ident = &ety.ident;
-    let range = quote!(#type_token #ident);
-    Error::new_spanned(range, "duplicate type")
+    Error::new_spanned(ety, "duplicate type")
 }
 
 fn duplicate_function(efn: &ExternFn) -> Error {

